local ball = ents.Derive("base") --this is actually making a new table, but has the things that base has
--local paddle = require "entities/paddle"

--making a new function called load that will run the setPos function with the x and y parameters
--this function is called when we call the create() function that is actually in entities.lua in the ents table
function ball:load(x, y)
    self:setPos(x, y) --this function is already made in base.lua which this has
    self.r = 8 --radius of circle
    self.speed = 300 --x speed
    self.dir = 2 --will start the ball in a direction either 1 or 2
    self.ascen = 300
end

function ball:getSize()
    return self.r;
end

function ball:direction(dt)
    if self.dir == 1 then
        self.x = self.x - self.speed * dt --moves the ball in the x direction
    else
        self.x = self.x + self.speed * dt
    end
    self.y = self.y + self.ascen * dt --will move the ball in the y direction
end

function ball:collision() --will be called every frame
    local swidth = love.graphics.getWidth()
    local wheight = love.graphics.getHeight()

    --FIXME: collision with sides of scren
    if self.x <= 0 then
        self.dir = 2
    elseif self.x >= swidth then
        self.dir = 1
        --collision with top and paddle
    elseif self.y <= 0 then --collision with the top of the scree
        self.ascen = self.ascen * -1 --will reverse the y direction of the ball
    --FIXME: collisionllsion with the paddle
    --elseif self.y >= paddle.y and self.x > paddle.x and self.x < paddle.x + 128 then
      --self.ascen = self.ascen * -1
    end
end

--this does the movement for the ball, called every update
function ball:update(dt)
    --ball movement, will make the ball move and change direction
    self:direction(dt)
    --collsion with paddle
    self:collision()
end

function ball:draw()
    love.graphics.circle("fill", self.x, self.y, self.r, 36)
end

return ball;
