local paddle = ents.Derive("base")

function paddle:load(x, y)
    self:setPos(x, y)
    self.width = 128
    self.height = 16
    self.speed = 300
    self.sWidth = love.graphics.getWidth()
end

function paddle:movePaddle(dt)
    if love.keyboard.isDown("left") then
        self.x = self.x - self.speed * dt
        if self.x <= 0 then
            self.x = 0
        end
    elseif love.keyboard.isDown("right") then
        self.x = self.x + self.speed * dt
        if self.x + self.width >= self.sWidth then
            self.x = self.sWidth - self.width
        end
    end
end

function paddle:update(dt)
    self:movePaddle(dt)
end

function paddle:draw()
    love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
end

return paddle;
